Package org.eclipse.m2m.atl.adt.ui.text.atl

# Class AtlCompletionProposal

java.lang.Object
org.eclipse.m2m.atl.adt.ui.text.atl.AtlCompletionProposal

All Implemented Interfaces:
  `Comparable<AtlCompletionProposal>`, `org.eclipse.jface.text.contentassist.ICompletionProposal`, `org.eclipse.jface.text.contentassist.ICompletionProposalExtension`, `org.eclipse.jface.text.contentassist.ICompletionProposalExtension2`, `org.eclipse.jface.text.contentassist.ICompletionProposalExtension3`

public class AtlCompletionProposal extends Object implements org.eclipse.jface.text.contentassist.ICompletionProposalExtension, org.eclipse.jface.text.contentassist.ICompletionProposalExtension2, org.eclipse.jface.text.contentassist.ICompletionProposalExtension3, org.eclipse.jface.text.contentassist.ICompletionProposal, Comparable<AtlCompletionProposal>
The ATL completion proposal definition.

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected static class`
`AtlCompletionProposal.ExitPolicy`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected org.eclipse.jface.text.ITextViewer`
`fTextViewer`
`protected boolean`
`fToggleEating`

## Constructor Summary

Constructors
Constructor
Description
`AtlCompletionProposal(String replacementString, int replacementOffset, int replacementLength, org.eclipse.swt.graphics.Image image, String displayString, int relevance, String additionalProposalInfo)`
Creates a new completion proposal.
`AtlCompletionProposal(String replacementString, int replacementOffset, int replacementLength, org.eclipse.swt.graphics.Image image, String displayString, int relevance, org.eclipse.jface.text.ITextViewer viewer, String additionalProposalInfo)`
Creates a new completion proposal.

## Method Summary

Modifier and Type
Method
Description
`void`
`apply(org.eclipse.jface.text.IDocument document)`
`void`
`apply(org.eclipse.jface.text.IDocument document, char trigger, int offset)`
`void`
`apply(org.eclipse.jface.text.ITextViewer viewer, char trigger, int stateMask, int offset)`
`int`
`compareTo(AtlCompletionProposal arg0)`
`String`
`getAdditionalProposalInfo()`
`org.eclipse.jface.text.contentassist.IContextInformation`
`getContextInformation()`
`int`
`getContextInformationPosition()`
`String`
`getDisplayString()`
`org.eclipse.swt.graphics.Image`
`getImage()`
`org.eclipse.jface.text.IInformationControlCreator`
`getInformationControlCreator()`
`int`
`getPrefixCompletionStart(org.eclipse.jface.text.IDocument document, int completionOffset)`
`CharSequence`
`getPrefixCompletionText(org.eclipse.jface.text.IDocument document, int completionOffset)`
`int`
`getRelevance()`
Gets the proposal's relevance.
`int`
`getReplacementLength()`
Gets the replacement length.
`int`
`getReplacementOffset()`
Gets the replacement offset.
`String`
`getReplacementString()`
Gets the replacement string.
`org.eclipse.swt.graphics.Point`
`getSelection(org.eclipse.jface.text.IDocument document)`
`char[]`
`getTriggerCharacters()`
`boolean`
`isValidFor(org.eclipse.jface.text.IDocument document, int offset)`
`void`
`selected(org.eclipse.jface.text.ITextViewer viewer, boolean smartToggle)`
`void`
`setContextInformation(org.eclipse.jface.text.contentassist.IContextInformation contextInformation)`
Sets the context information.
`void`
`setCursorPosition(int cursorPosition)`
Sets the cursor position relative to the insertion offset.
`void`
`setImage(org.eclipse.swt.graphics.Image image)`
Sets the image.
`void`
`setRelevance(int relevance)`
Sets the proposal's relevance.
`void`
`setReplacementLength(int replacementLength)`
Sets the replacement length.
`void`
`setReplacementOffset(int replacementOffset)`
Sets the replacement offset.
`void`
`setReplacementString(String replacementString)`
Sets the replacement string.
`void`
`setTriggerCharacters(char[] triggerCharacters)`
Sets the trigger characters.
`protected boolean`
`startsWith(org.eclipse.jface.text.IDocument document, int offset, String word)`
Returns `true` if a words starts with the code completion prefix in the document, `false` otherwise.
`void`
`unselected(org.eclipse.jface.text.ITextViewer viewer)`
`void`
`updateReplacementLength(int length)`
`void`
`updateReplacementOffset(int newOffset)`
`boolean`
`validate(org.eclipse.jface.text.IDocument document, int offset, org.eclipse.jface.text.DocumentEvent event)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### fTextViewer

protected org.eclipse.jface.text.ITextViewer fTextViewer

### fToggleEating

protected boolean fToggleEating

## Constructor Details

### AtlCompletionProposal

public AtlCompletionProposal(String replacementString, int replacementOffset, int replacementLength, org.eclipse.swt.graphics.Image image, String displayString, int relevance, String additionalProposalInfo)
Creates a new completion proposal. All fields are initialized based on the provided information.

Parameters:
  `replacementString` - the actual string to be inserted into the document
  `replacementOffset` - the offset of the text to be replaced
  `replacementLength` - the length of the text to be replaced
  `image` - the image to display for this proposal
  `displayString` - the string to be displayed for the proposal If set to `null`, the replacement string will be taken as display string.
  `relevance` - the relevance of the proposal
  `additionalProposalInfo` - the additional informations

### AtlCompletionProposal

public AtlCompletionProposal(String replacementString, int replacementOffset, int replacementLength, org.eclipse.swt.graphics.Image image, String displayString, int relevance, org.eclipse.jface.text.ITextViewer viewer, String additionalProposalInfo)
Creates a new completion proposal. All fields are initialized based on the provided information.

Parameters:
  `replacementString` - the actual string to be inserted into the document
  `replacementOffset` - the offset of the text to be replaced
  `replacementLength` - the length of the text to be replaced
  `image` - the image to display for this proposal
  `displayString` - the string to be displayed for the proposal
  `relevance` - the relevance of the proposal
  `viewer` - the text viewer for which this proposal is computed, may be `null` If set to `null`, the replacement string will be taken as display string.
  `additionalProposalInfo` - the additional informations

## Method Details

### apply

public void apply(org.eclipse.jface.text.IDocument document)

Specified by:
  `apply` in interface `org.eclipse.jface.text.contentassist.ICompletionProposal`

### apply

public void apply(org.eclipse.jface.text.IDocument document, char trigger, int offset)

Specified by:
  `apply` in interface `org.eclipse.jface.text.contentassist.ICompletionProposalExtension`

### apply

public void apply(org.eclipse.jface.text.ITextViewer viewer, char trigger, int stateMask, int offset)

Specified by:
  `apply` in interface `org.eclipse.jface.text.contentassist.ICompletionProposalExtension2`

### compareTo

public int compareTo(AtlCompletionProposal arg0)

Specified by:
  `compareTo` in interface `Comparable<AtlCompletionProposal>`

### getAdditionalProposalInfo

public String getAdditionalProposalInfo()

Specified by:
  `getAdditionalProposalInfo` in interface `org.eclipse.jface.text.contentassist.ICompletionProposal`

### getContextInformation

public org.eclipse.jface.text.contentassist.IContextInformation getContextInformation()

Specified by:
  `getContextInformation` in interface `org.eclipse.jface.text.contentassist.ICompletionProposal`

### getContextInformationPosition

public int getContextInformationPosition()

Specified by:
  `getContextInformationPosition` in interface `org.eclipse.jface.text.contentassist.ICompletionProposalExtension`

### getDisplayString

public String getDisplayString()

Specified by:
  `getDisplayString` in interface `org.eclipse.jface.text.contentassist.ICompletionProposal`

### getImage

public org.eclipse.swt.graphics.Image getImage()

Specified by:
  `getImage` in interface `org.eclipse.jface.text.contentassist.ICompletionProposal`

### getInformationControlCreator

public org.eclipse.jface.text.IInformationControlCreator getInformationControlCreator()

Specified by:
  `getInformationControlCreator` in interface `org.eclipse.jface.text.contentassist.ICompletionProposalExtension3`

### getPrefixCompletionStart

public int getPrefixCompletionStart(org.eclipse.jface.text.IDocument document, int completionOffset)

Specified by:
  `getPrefixCompletionStart` in interface `org.eclipse.jface.text.contentassist.ICompletionProposalExtension3`

### getPrefixCompletionText

public CharSequence getPrefixCompletionText(org.eclipse.jface.text.IDocument document, int completionOffset)

Specified by:
  `getPrefixCompletionText` in interface `org.eclipse.jface.text.contentassist.ICompletionProposalExtension3`

### getRelevance

public int getRelevance()
Gets the proposal's relevance.

Returns:
  Returns a int

### getReplacementLength

public int getReplacementLength()
Gets the replacement length.

Returns:
  Returns a int

### getReplacementOffset

public int getReplacementOffset()
Gets the replacement offset.

Returns:
  Returns a int

### getReplacementString

public String getReplacementString()
Gets the replacement string.

Returns:
  Returns a String

### getSelection

public org.eclipse.swt.graphics.Point getSelection(org.eclipse.jface.text.IDocument document)

Specified by:
  `getSelection` in interface `org.eclipse.jface.text.contentassist.ICompletionProposal`

### getTriggerCharacters

public char[] getTriggerCharacters()

Specified by:
  `getTriggerCharacters` in interface `org.eclipse.jface.text.contentassist.ICompletionProposalExtension`

### isValidFor

public boolean isValidFor(org.eclipse.jface.text.IDocument document, int offset)

Specified by:
  `isValidFor` in interface `org.eclipse.jface.text.contentassist.ICompletionProposalExtension`

### selected

public void selected(org.eclipse.jface.text.ITextViewer viewer, boolean smartToggle)

Specified by:
  `selected` in interface `org.eclipse.jface.text.contentassist.ICompletionProposalExtension2`

### setContextInformation

public void setContextInformation(org.eclipse.jface.text.contentassist.IContextInformation contextInformation)
Sets the context information.

Parameters:
  `contextInformation` - The context information associated with this proposal

### setCursorPosition

public void setCursorPosition(int cursorPosition)
Sets the cursor position relative to the insertion offset. By default this is the length of the completion string (Cursor positioned after the completion)

Parameters:
  `cursorPosition` - The cursorPosition to set

### setImage

public void setImage(org.eclipse.swt.graphics.Image image)
Sets the image.

Parameters:
  `image` - The image to set

### setRelevance

public void setRelevance(int relevance)
Sets the proposal's relevance.

Parameters:
  `relevance` - The relevance to set

### setReplacementLength

public void setReplacementLength(int replacementLength)
Sets the replacement length.

Parameters:
  `replacementLength` - The replacementLength to set

### setReplacementOffset

public void setReplacementOffset(int replacementOffset)
Sets the replacement offset.

Parameters:
  `replacementOffset` - The replacement offset to set

### setReplacementString

public void setReplacementString(String replacementString)
Sets the replacement string.

Parameters:
  `replacementString` - The replacement string to set

### setTriggerCharacters

public void setTriggerCharacters(char[] triggerCharacters)
Sets the trigger characters.

Parameters:
  `triggerCharacters` - The set of characters which can trigger the application of this completion proposal

### startsWith

protected boolean startsWith(org.eclipse.jface.text.IDocument document, int offset, String word)
Returns `true` if a words starts with the code completion prefix in the document, `false` otherwise.

### unselected

public void unselected(org.eclipse.jface.text.ITextViewer viewer)

Specified by:
  `unselected` in interface `org.eclipse.jface.text.contentassist.ICompletionProposalExtension2`
See Also:
  - `ICompletionProposalExtension2.unselected(org.eclipse.jface.text.ITextViewer)`

### updateReplacementLength

public void updateReplacementLength(int length)

Parameters:
  `length` -

### updateReplacementOffset

public void updateReplacementOffset(int newOffset)

Parameters:
  `newOffset` -

### validate

public boolean validate(org.eclipse.jface.text.IDocument document, int offset, org.eclipse.jface.text.DocumentEvent event)

Specified by:
  `validate` in interface `org.eclipse.jface.text.contentassist.ICompletionProposalExtension2`